"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable:max-file-line-count
require("mocha"); // tslint:disable-line:no-import-side-effect
var assert = require("power-assert");
var Cursor_1 = require("../../types/Cursor");
var PaginationDirection_1 = require("../../types/PaginationDirection");
var SortOrder_1 = require("../../types/SortOrder");
var createCursorFromEntity_1 = require("../../utils/createCursorFromEntity");
var testEntity_1 = require("../utils/testEntity");
exports.default = (function (facade) {
    var sort = { id: SortOrder_1.asc };
    var firstId = 'test_id_1';
    var secondId = 'test_id_2';
    var firstEntity = __assign({}, testEntity_1.testEntity, { id: firstId });
    var secondEntity = __assign({}, testEntity_1.testEntity, { id: secondId });
    var firstCursor = createCursorFromEntity_1.default(firstEntity, sort);
    var secondCursor = createCursorFromEntity_1.default(secondEntity, sort);
    var createTestEntities = function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, facade.createEntity({ id: firstId, entity: firstEntity })];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, facade.createEntity({ id: secondId, entity: secondEntity })];
                case 2:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); };
    var paginate = function (cursor, direction) { return __awaiter(_this, void 0, void 0, function () {
        var pagination;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    pagination = { cursor: cursor, direction: direction, limit: 1 };
                    return [4 /*yield*/, createTestEntities()];
                case 1:
                    _a.sent();
                    return [2 /*return*/, facade.getEntities({ pagination: pagination, sort: sort })];
            }
        });
    }); };
    it('should return all entities when pagination is not defined', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, createTestEntities()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, facade.getEntities({})];
                case 2:
                    result = _a.sent();
                    assert.deepEqual(result, {
                        backwardCursor: firstCursor,
                        entities: [firstEntity, secondEntity],
                        forwardCursor: secondCursor,
                        hasMoreBackward: false,
                        hasMoreForward: false,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return first entity when paginating forward with start cursor', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, paginate(Cursor_1.start, PaginationDirection_1.forward)];
                case 1:
                    result = _a.sent();
                    assert.deepEqual(result, {
                        backwardCursor: firstCursor,
                        entities: [firstEntity],
                        forwardCursor: firstCursor,
                        hasMoreBackward: false,
                        hasMoreForward: true,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return second entity when paginating forward with first cursor', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, paginate(firstCursor, PaginationDirection_1.forward)];
                case 1:
                    result = _a.sent();
                    assert.deepEqual(result, {
                        backwardCursor: secondCursor,
                        entities: [secondEntity],
                        forwardCursor: secondCursor,
                        hasMoreBackward: true,
                        hasMoreForward: false,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return no entities when paginating forward with second cursor', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, paginate(secondCursor, PaginationDirection_1.forward)];
                case 1:
                    result = _a.sent();
                    assert.deepEqual(result, {
                        backwardCursor: secondCursor,
                        entities: [],
                        forwardCursor: secondCursor,
                        hasMoreBackward: true,
                        hasMoreForward: false,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return second entity when paginating backward with start cursor', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, paginate(Cursor_1.start, PaginationDirection_1.backward)];
                case 1:
                    result = _a.sent();
                    assert.deepEqual(result, {
                        backwardCursor: secondCursor,
                        entities: [secondEntity],
                        forwardCursor: secondCursor,
                        hasMoreBackward: true,
                        hasMoreForward: false,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return first entity when paginating backward with second cursor', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, paginate(secondCursor, PaginationDirection_1.backward)];
                case 1:
                    result = _a.sent();
                    assert.deepEqual(result, {
                        backwardCursor: firstCursor,
                        entities: [firstEntity],
                        forwardCursor: firstCursor,
                        hasMoreBackward: false,
                        hasMoreForward: true,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    it('should return no entities when paginating backward with first cursor', function () { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, paginate(firstCursor, PaginationDirection_1.backward)];
                case 1:
                    result = _a.sent();
                    assert.deepEqual(result, {
                        backwardCursor: firstCursor,
                        entities: [],
                        forwardCursor: firstCursor,
                        hasMoreBackward: false,
                        hasMoreForward: true,
                    });
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=paginationTest.js.map