"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var convertPropertyFilter = function (_a) {
    var converter = _a.converter, filter = _a.filter, propertyName = _a.propertyName, _b = _a.useConverter, useConverter = _b === void 0 ? false : _b;
    if (lodash_1.isPlainObject(filter)) {
        return lodash_1.mapValues(filter, function (subFilter, filterKey) {
            if (filterKey !== propertyName) {
                return convertPropertyFilter({
                    converter: converter,
                    filter: subFilter,
                    propertyName: propertyName,
                    useConverter: useConverter,
                });
            }
            return convertPropertyFilter({
                converter: converter,
                filter: subFilter,
                propertyName: propertyName,
                useConverter: true,
            });
        });
    }
    if (lodash_1.isArray(filter)) {
        return filter.map(function (subFilter) {
            return convertPropertyFilter({
                converter: converter,
                filter: subFilter,
                propertyName: propertyName,
                useConverter: useConverter,
            });
        });
    }
    if (!useConverter) {
        return filter;
    }
    return converter(filter);
};
exports.default = convertPropertyFilter;
//# sourceMappingURL=index.js.map