"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha"); // tslint:disable-line:no-import-side-effect
var assert = require("power-assert");
var index_1 = require("./index");
describe('convertPropertyFilter', function () {
    var originalValue = 10;
    var expectedValue = '10';
    var converter = function (value) { return value.toString(); };
    var propertyName = 'numberProp';
    it('should convert the property value when used inside a prop filter', function () {
        var filter = { numberProp: { $gt: originalValue } };
        var newFilter = index_1.default({ converter: converter, filter: filter, propertyName: propertyName });
        var expectedFilter = { numberProp: { $gt: expectedValue } };
        assert.deepEqual(newFilter, expectedFilter);
    });
    it('should convert the property value when used inside an entity filter', function () {
        var filter = { numberProp: originalValue, stringProp: 'test_string' };
        var newFilter = index_1.default({ converter: converter, filter: filter, propertyName: propertyName });
        var expectedFilter = { numberProp: expectedValue, stringProp: 'test_string' };
        assert.deepEqual(newFilter, expectedFilter);
    });
    it('should convert the property value when used inside a condition filter', function () {
        var filter = { $and: [{ numberProp: originalValue }] };
        var newFilter = index_1.default({ converter: converter, filter: filter, propertyName: propertyName });
        var expectedFilter = { $and: [{ numberProp: expectedValue }] };
        assert.deepEqual(newFilter, expectedFilter);
    });
});
//# sourceMappingURL=index.test.js.map