"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha"); // tslint:disable-line:no-import-side-effect
var assert = require("power-assert");
var testEntity_1 = require("../../tests/utils/testEntity");
var Cursor_1 = require("../../types/Cursor");
var SortOrder_1 = require("../../types/SortOrder");
var index_1 = require("./index");
describe('createCursorsFromEntities', function () {
    var sort = { id: SortOrder_1.asc };
    var firstId = 'test_id_1';
    var secondId = 'test_id_2';
    var firstEntity = __assign({}, testEntity_1.testEntity, { id: firstId });
    var secondEntity = __assign({}, testEntity_1.testEntity, { id: secondId });
    var firstCursor = 'eyJpZCI6InRlc3RfaWRfMSJ9';
    var secondCursor = 'eyJpZCI6InRlc3RfaWRfMiJ9';
    it('should return the correct cursors when there are no entities', function () {
        var entities = [];
        var cursor = Cursor_1.start;
        var actualResult = index_1.default({ cursor: cursor, entities: entities, sort: sort });
        assert.deepEqual(actualResult, {
            backwardCursor: Cursor_1.start,
            forwardCursor: Cursor_1.start,
        });
    });
    it('should return the correct cursors when there is one entity', function () {
        var entities = [firstEntity];
        var cursor = Cursor_1.start;
        var actualResult = index_1.default({ cursor: cursor, entities: entities, sort: sort });
        assert.deepEqual(actualResult, {
            backwardCursor: firstCursor,
            forwardCursor: firstCursor,
        });
    });
    it('should return the correct cursors when there are many entities', function () {
        var entities = [firstEntity, secondEntity];
        var cursor = Cursor_1.start;
        var actualResult = index_1.default({ cursor: cursor, entities: entities, sort: sort });
        assert.deepEqual(actualResult, {
            backwardCursor: firstCursor,
            forwardCursor: secondCursor,
        });
    });
});
//# sourceMappingURL=index.test.js.map