"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Cursor_1 = require("../../types/Cursor");
var PaginationDirection_1 = require("../../types/PaginationDirection");
var createCursorsFromEntities_1 = require("../createCursorsFromEntities");
exports.default = (function (_a) {
    var entities = _a.entities, isEnd = _a.isEnd, pagination = _a.pagination, sort = _a.sort;
    var direction = pagination.direction, cursor = pagination.cursor;
    var isBackward = direction === PaginationDirection_1.backward;
    var isForward = direction === PaginationDirection_1.forward;
    var isStart = cursor === Cursor_1.start;
    var hasMoreBackward = (isBackward && !isEnd) || (isForward && !isStart);
    var hasMoreForward = (isForward && !isEnd) || (isBackward && !isStart);
    var _b = createCursorsFromEntities_1.default({ entities: entities, cursor: cursor, sort: sort }), backwardCursor = _b.backwardCursor, forwardCursor = _b.forwardCursor;
    return { entities: entities, forwardCursor: forwardCursor, backwardCursor: backwardCursor, hasMoreBackward: hasMoreBackward, hasMoreForward: hasMoreForward };
});
//# sourceMappingURL=index.js.map