"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var atob = require("atob");
var lodash_1 = require("lodash");
var Cursor_1 = require("../../types/Cursor");
var PaginationDirection_1 = require("../../types/PaginationDirection");
var SortOrder_1 = require("../../types/SortOrder");
var xor = function (conditionA, conditionB) {
    return (conditionA && !conditionB) || (!conditionA && conditionB);
};
exports.default = (function (pagination, sort) {
    if (pagination.cursor === Cursor_1.start) {
        return {};
    }
    var cursor = pagination.cursor;
    var cursorObj = JSON.parse(atob(cursor));
    var filter = lodash_1.mapValues(cursorObj, function (cursorValue, sortKey) {
        var ascendingPagination = !xor(lodash_1.get(sort, sortKey) === SortOrder_1.asc, pagination.direction === PaginationDirection_1.forward);
        if (ascendingPagination) {
            if (sortKey === 'id') {
                return { $gt: cursorValue };
            }
            else {
                return { $gte: cursorValue };
            }
        }
        else {
            if (sortKey === 'id') {
                return { $lt: cursorValue };
            }
            else {
                return { $lte: cursorValue };
            }
        }
    });
    return filter;
});
//# sourceMappingURL=index.js.map